/****************************************************************************
 * Fairfield University
 * SW 511
 * Glenn Josefiak
 ***************************************************************************/

public class Complex{
	float real;
	float imag;

	public Complex(float real, float imag){
		this.real = real;
		this.imag = imag;
	}
	
	public float getReal(){
		return real;
	}
	
	public float getImag(){
		return imag;
	}
	
	public float getMagnitude(){
		return (float)Math.sqrt(real*real + imag*imag);
	}

	public float getAngle(){
		return (float)Math.atan2(imag,real);
	}		

	public static Complex add(Complex x, Complex y){
		float real = x.getReal() + y.getReal();
		float imag = x.getImag() + y.getImag();
		
		return new Complex(real, imag);
	}
	
	public static Complex subtract(Complex x, Complex y){
		float real = x.getReal() - y.getReal();
		float imag = x.getImag() - y.getImag();
		
		return new Complex(real, imag);	
	}
	
	public static Complex multiply(Complex x, Complex y){
		float real = x.getReal() * y.getReal() -
					 x.getImag() * y.getImag();
					 
		float imag = x.getReal() * y.getImag() +
					 x.getImag() * y.getReal();
					 
		return new Complex(real, imag);					 					
	}
	
	public static Complex divide(Complex x, Complex y){
		float scale = y.getReal() * y.getReal() +
		              y.getImag() * y.getImag();
		
		float real = x.getReal() * y.getReal() +
					 x.getImag() * y.getImag();

		float imag = x.getImag() * y.getReal() -
					 x.getReal() * y.getImag();
					 
		return new Complex(real/scale, imag/scale);					 
	}
}
	